# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', ' 106 ', 'PRO', 0.08740158415607002, (133.526, 150.77, 156.72)), ('B', '  67 ', 'HIS', 0.03369882767371784, (145.78399999999993, 115.537, 142.117)), ('B', ' 123 ', 'MET', 0.04062537930234586, (160.34299999999993, 115.606, 140.685)), ('B', ' 259 ', 'ASN', 0.022474705873248523, (121.042, 146.731, 144.83899999999994)), ('B', ' 343 ', 'ASP', 0.04165031171819918, (129.39899999999994, 114.15600000000002, 150.36299999999997))]
data['omega'] = [('A', '  62 ', 'PRO', None, (131.70099999999994, 173.276, 127.582)), ('A', ' 272 ', 'LEU', None, (148.23199999999997, 152.467, 130.224)), ('B', '  62 ', 'PRO', None, (154.21699999999996, 112.72899999999996, 127.624))]
data['rota'] = [('A', '  74 ', 'GLU', 0.20708772577364712, (131.91699999999994, 183.691, 151.39799999999994)), ('A', ' 107 ', 'GLU', 0.2770564101812533, (136.167, 150.614, 153.899)), ('A', ' 123 ', 'MET', 0.0004174976089146048, (125.60300000000004, 170.356, 140.723)), ('A', ' 169 ', 'VAL', 0.15072991025113033, (147.612, 172.948, 152.24199999999996)), ('A', ' 268 ', 'VAL', 0.1603449404005833, (150.83299999999994, 156.618, 139.589)), ('A', ' 274 ', 'THR', 0.11555750240822937, (152.57, 150.653, 133.188)), ('A', ' 283 ', 'GLN', 0.23195283145329287, (155.859, 139.149, 144.412)), ('B', '   2 ', 'THR', 0.25087370294339506, (157.862, 96.212, 148.214)), ('B', '  48 ', 'SER', 0.08661343326128686, (142.018, 120.766, 136.17199999999997)), ('B', '  59 ', 'THR', 0.07358394832285517, (152.535, 120.195, 131.241)), ('B', ' 107 ', 'GLU', 0.1961637008189564, (149.738, 135.364, 153.861)), ('B', ' 123 ', 'MET', 0.1312801375243149, (160.34299999999993, 115.606, 140.685)), ('B', ' 166 ', 'LEU', 0.08766692909996483, (140.06099999999995, 108.331, 152.03799999999998)), ('B', ' 169 ', 'VAL', 0.06965897362010302, (138.196, 112.911, 152.34799999999998)), ('B', ' 267 ', 'GLU', 0.003485496910863247, (134.902, 132.897, 139.471))]
data['cbeta'] = [('A', '  18 ', 'LYS', ' ', 0.3542082827353966, (144.038, 170.004, 122.09599999999998)), ('A', ' 188 ', 'LYS', ' ', 0.2716982650043703, (147.32099999999994, 147.643, 154.395)), ('A', ' 328 ', 'VAL', ' ', 0.29061063803983006, (139.84499999999994, 166.687, 153.935)), ('B', '  18 ', 'LYS', ' ', 0.2619897163434182, (141.87699999999995, 116.003, 121.95299999999999)), ('B', ' 161 ', 'ASP', ' ', 0.25782500840564326, (144.288, 112.035, 162.105))]
data['probe'] = [(' B 123  MET  HA ', ' B 123  MET  HE2', -0.49, (159.005, 115.451, 141.617)), (' A  68  GLU  HG2', ' A 174  CYS  HB3', -0.478, (144.224, 167.884, 143.895)), (' B 282  CYS  HB3', ' B 287  GLY  HA3', -0.423, (133.31, 144.654, 144.579)), (' B 105  HIS  CE1', ' B 107  GLU  OE2', -0.421, (151.466, 138.964, 153.958)), (' A 243  PRO  HA ', ' A 250  ILE HD13', -0.409, (163.274, 150.345, 133.079)), (' A 160  ILE HD11', ' A 328  VAL HG12', -0.408, (140.202, 169.32, 154.894))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
